<?php

/**
 * Definition of the mailq custom mail backend to collect all mails 
 * into the mailq queue to be processed later in cron runs.
 * This will get enabled only when not running crons.
 */
if ($_GET['q'] != 'admin/reports/status/run-cron' && (request_uri() != '/cron.php')) {
  function drupal_mail_wrapper(&$message) {
    if (MAILQ_DEBUG_MODE) {
      watchdog(
        'mailq',
        'Queued mail to @to with message id @id and subject @subject',
        array(
          '@to' => $message['to'],
          '@id' => $message['id'],
          '@subject' => $message['subject'],
        ),
        WATCHDOG_DEBUG
      );
    }
    // Place this into the queue
    $current_smtp_lib = variable_get('mailq_send_library', '');
    //TODO - This check should not be needed if the data is saved correcly. Add 
    // this in an update function to help existing sites update correctly.
    if ($current_smtp_lib == '') {
      $current_smtp_lib = 'drupal_default';
    }
    $headers = serialize($message['headers']);
    $drupal_sender = variable_get('site_mail', 'drupal@localhost');
    $queued = db_query(
      "INSERT INTO {mailq_active_queue} ".
        "(".
          "mailkey, header, sender, recpt, ".
          "subject, body, queue_date, queue_send, ".
          "queue_attempts, queue_engine_used, queue_priority, queue_status ".
        ") ".
        "VALUES ".
        "(".
          "'%s', '%s', '%s', '%s', ".
          "'%s', '%s', %d, %d, ".
          "%d, '%s', %d, %d ".
        ") ",
      $message['id'], $headers, $message['from'], $message['to'],
      $message['subject'], $message['body'], time(), 0,
      0, $current_smtp_lib, MAILQ_PRIORITY_NORMAL, MAILQ_STATUS_QUEUED
    );
    return $queued;
  }
}
